<?php
declare (strict_types = 1);

namespace app\admin\listener;

class ReportCode
{
    protected $model;
    /**
     * 事件监听处理
     *
     * @return mixed
     */
    public function handle($event)
    {
        $this->model = new \app\admin\model\ReportCode();
        if($event['type']=='add'){

            $this->addField($event['param']);
        }
        if ($event['type']=='sub'){
            $this->subField($event['param']);
        }
    }

    private function subField($param){
        if(is_string($param['value'])){
            $this->model->whereFindInSet($param['key'],$param['value'])->rmField($param['key'],$param['value'])->save();
        }
        if(is_array($param['value'])){
           foreach ($param['value'] as $v){
               $this->model->whereFindInSet($param['key'],$v)->rmField($param['key'],$v)->save();
           }
        }
    }

    private function addField($param){
        $info= $this->model->where([$param['main']['key']=>$param['main']['value']])->setField($param['key'],$param['value']);
    }
}
