<?php
declare (strict_types = 1);

namespace app\admin\model;

use think\Model;

/**
 * @mixin \think\Model
 */
class QrdInfo extends Model
{
    protected $createTime="addtime";
    protected $updateTime="updatetime";

    public function Category()
    {
        return $this->belongsTo(OrderCategory::class,"sequenceNo",'code')->bind(["cat_code","cat_name","cat_tax"=>"tax","inv_good_name"]);
    }
}
